import datetime


class GnssDateLocBuilder:
    EPOCH_TIME = datetime.datetime(1980, 1, 6)

    def __init__(self):
        pass

    @staticmethod
    def get_delay_due_to_leap_second():
        """ Return the delay due to leap second at the time of writing this function..."""
        return datetime.timedelta(seconds=18)

    @staticmethod
    def date_to_gps_format(date):
        delta_since_epoch = date - GnssDateLocBuilder.EPOCH_TIME
        return int(delta_since_epoch.total_seconds())

    @staticmethod
    def get_now_gps():
        today = datetime.datetime.utcnow() + GnssDateLocBuilder.get_delay_due_to_leap_second()
        gps_seconds = GnssDateLocBuilder.date_to_gps_format(today)
        return gps_seconds
