from json import load
from .Job import Job


class JobReader:
    INFINITE_LOOPS_KEY = "infinite_loops"
    JOBS_KEY = "jobs"

    def __init__(self):
        self.jobs = list()
        self.infinite_execution = False

    def read_from_file(self, filename):
        with open(filename, "r") as f:
            configuration_raw = load(f)

        job_descriptions = [job for job in configuration_raw[JobReader.JOBS_KEY]]
        self.infinite_execution = configuration_raw[JobReader.INFINITE_LOOPS_KEY]

        for job_id, job_desc in enumerate(job_descriptions):
            job = JobReader.job_from_json(job_desc, job_id)
            self.jobs.extend([job] * job.n_iterations)

    @staticmethod
    def job_from_json(job_json, job_id):
        job = Job.from_dict(job_json)
        job.id = job_id
        return job
