class CommandBase:
    def __init__(self):
        self._sent_time = None

    @staticmethod
    def get_com_code():
        raise NotImplementedError

    def convert_to_bytes(self):
        com_code = self.get_com_code()
        payload_bytes = self.payload_to_bytes()
        payload_size = len(payload_bytes)
        return com_code + payload_size.to_bytes(2, "little") + payload_bytes

    def payload_to_bytes(self):
        raise NotImplementedError

    @property
    def sent_time(self):
        return self._sent_time

    @sent_time.setter
    def sent_time(self, time):
        self._sent_time = time

    def __str__(self):
        return "{}: {}".format(self.__class__.__name__, self.payload_to_bytes())
