from .CommandBase import CommandBase


class CommandSetDateLoc(CommandBase):
    LOC_MULTIPLIER = 1000

    def __init__(self):
        self._gps_time = None
        self._gps_assisted_location = None

    @staticmethod
    def get_com_code():
        return b"\x05\x00"

    def payload_to_bytes(self):
        gnss_seconds = self.gps_time.to_bytes(4, byteorder="little")
        longitude, latitude, altitude = (
            int(element * CommandSetDateLoc.LOC_MULTIPLIER).to_bytes(
                4, byteorder="little", signed=True
            )
            for element in [
                self._gps_assisted_location.longitude,
                self._gps_assisted_location.latitude,
                self._gps_assisted_location.altitude,
            ]
        )
        return gnss_seconds + longitude + latitude + altitude

    @property
    def gps_time(self):
        return self._gps_time

    @gps_time.setter
    def gps_time(self, gnss_time):
        self._gps_time = gnss_time

    @property
    def gps_assisted_location(self):
        return self._gps_assisted_location

    @gps_assisted_location.setter
    def gps_assisted_location(self, location):
        self._gps_assisted_location = location
