from .ResponseBase import ResponseBase


class ResponseFetchResult(ResponseBase):
    def __init__(self, receive_time, nbr_results):
        super().__init__(receive_time)
        self.nbr_results = nbr_results

    @classmethod
    def get_response_code(cls):
        return b"\x03\x00"

    @classmethod
    def from_response_raw(cls, response_raw):
        receive_time = response_raw.receive_time
        nbr_results = int.from_bytes(
            response_raw.payload_bytes[0:1], byteorder="little"
        )
        response_result = ResponseFetchResult(
            receive_time=receive_time, nbr_results=nbr_results
        )
        return response_result

    def __str__(self):
        return "{} result(s) to be fetched".format(self.nbr_results)
