from .ResponseBase import ResponseBase
from lr1110evk.BaseTypes import ScannedGnss


class ResponseGnssAssistedResult(ResponseBase):
    def __init__(self, receive_time, gnss_scan):
        super().__init__(receive_time)
        self.gnss_scan = gnss_scan

    @classmethod
    def from_response_raw(cls, response_raw):
        receive_time = response_raw.receive_time
        gnss_scan = ScannedGnss.from_bytes(response_raw.payload_bytes, receive_time)
        response_gnss = ResponseGnssAssistedResult(
            receive_time=receive_time, gnss_scan=gnss_scan
        )
        return response_gnss

    @classmethod
    def get_response_code(cls):
        return b"\x83\x00"

    def __str__(self):
        return "GnssAssistedResult({}): {}".format(self.reception_time, self.gnss_scan)
