from .ResponseBase import ResponseBase


class ResponseLog(ResponseBase):
    def __init__(self, reception_time, message):
        self.reception_time = reception_time
        self.message = message

    @classmethod
    def get_response_code(cls):
        return b"\x84\x00"

    @classmethod
    def from_response_raw(cls, response_raw):
        receive_time = response_raw.receive_time
        message = str(response_raw.payload_bytes)
        response_log = ResponseLog(reception_time=receive_time, message=message)
        return response_log
