from .ResponseBase import ResponseBase


class ResponseStatus(ResponseBase):
    def __init__(self, reception_time, count_error, count_tx, count_rx):
        super().__init__(reception_time)
        self.count_error = count_error
        self.count_tx = count_tx
        self.count_rx = count_rx

    def __str__(self):
        return "Status: count error: {}, count rx: {}, count tx: {}".format(
            self.count_error, self.count_rx, self.count_tx
        )

    @classmethod
    def get_response_code(cls):
        return b"\x00\x00"

    @classmethod
    def from_response_raw(cls, response_raw):
        count_error = int.from_bytes(
            response_raw.payload_bytes[0:2], byteorder="little"
        )
        count_rx = int.from_bytes(response_raw.payload_bytes[2:4], byteorder="little")
        count_tx = int.from_bytes(response_raw.payload_bytes[4:6], byteorder="little")
        response = ResponseStatus(
            reception_time=response_raw.receive_time,
            count_error=count_error,
            count_rx=count_rx,
            count_tx=count_tx,
        )
        return response
