from .ResponseBase import ResponseBase
from lr1110evk.BaseTypes import ScannedMacAddress


class ResponseWifiResult(ResponseBase):
    def __init__(self, receive_time, mac_address):
        super().__init__(receive_time)
        self.mac_address = mac_address

    @classmethod
    def from_response_raw(cls, response_raw):
        receive_time = response_raw.receive_time
        mac_address = ScannedMacAddress.from_bytes(
            response_raw.payload_bytes, receive_time
        )
        response_mac_address = ResponseWifiResult(
            receive_time=receive_time, mac_address=mac_address
        )
        return response_mac_address

    @classmethod
    def get_response_code(cls):
        return b"\x81\x00"

    def __str__(self):
        return "WifiResult({}): {}".format(self.reception_time, self.mac_address)
